<template>
  <div v-if="editMode">
    [[ CKEDITOR ]]
    <div contenteditable="true" @input="update">{{ textareaData }}</div>
  </div>
  <div v-else-if="textareaData">
    {{ textareaData }}
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditableData: 'Y3TI/getEditableData',
      editMode: 'Y3TI/editMode'
    }),

    editablePath () {
      return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    },

    textareaData () {
      return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    }),

    update (e) {
      this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    }
  }
}
</script>

<style lang="scss" scoped>
</style>
